//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|   ,   , -, 2007.         |
//+------------------------------------------------------------------+
#property  copyright "ap"
#property  link      "ekr-ap@mail.ru"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Bisque
#property  indicator_color2  Red
#property  indicator_color3  Red
#property  indicator_color4  Blue
#property  indicator_width1  2
#property  indicator_width3  2
//---- indicator parameters
extern int EMA1=20;
extern int EMA220;
extern int Div1=2;
extern int Div2=3;

//---- indicator buffers
double     Buffer_b[],Buffer_a[];
double     SignalBuffer2[],SignalBuffer[];
int LastBars=0, pred;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_HISTOGRAM);
   
   
   SetIndexStyle(1,DRAW_LINE);
     SetIndexStyle(2,DRAW_HISTOGRAM);
  
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,Buffer_b);
   SetIndexBuffer(1,SignalBuffer);
   SetIndexBuffer(2,Buffer_a);
   SetIndexBuffer(3,SignalBuffer2);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(2,0.0);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("Bolinger-analiz("+DoubleToStr(EMA1,0)+" "+DoubleToStr(Div1,0)+")");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"al");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"SIGNAL");
//---- initialization done
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit,i;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd counted in the 1-st buffer
   
   limit=1000;
   for(i=0; i<limit; i++)
   {
   SignalBuffer[i]=iBands(NULL,0,EMA1,Div1,0,PRICE_CLOSE,1,i)-iBands(NULL,0,EMA1,Div1,0,PRICE_CLOSE,2,i);
  
      }
   
   for(i=0; i<limit; i++)
   {
   if (SignalBuffer[i]>SignalBuffer[i+1]) {Buffer_b[i]=SignalBuffer[i];Buffer_a[i]=0;} else  {Buffer_a[i]=SignalBuffer[i];Buffer_b[i]=0;}
   if(i+20<limit) {SignalBuffer2[i]=iMAOnArray(SignalBuffer,0,5,0,MODE_EMA,i);}
   }
   
   
//---- done
   return(0);
  }
//+------------------------------------------------------------------+